3 # resolve python-version to use
4 if [ "$PYTHON" == "" ] ; then
5 if ! PYTHON=$(command -v python || command -v python2 || command -v python 2.7)
7 echo "Unable to locate build-dependency python2.x!" 1>&2
12 # validate python-dependency
13 # useful in case of explicitly set option.
14 if ! command -v $PYTHON > /dev/null
16 echo "Unable to locate build-dependency python2.x ($PYTHON)!" 1>&2
22 echo "Usage: $0 [BuildArch] [BuildType] [verbose] [coverage] [cross] [clangx.y] [ninja] [configureonly] [skipconfigure] [skipnative] [skipmscorlib] [skiptests] [stripsymbols] [cmakeargs] [bindir]"
23 echo "BuildArch can be: x64, x86, arm, armel, arm64"
24 echo "BuildType can be: debug, checked, release"
25 echo "coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
26 echo "ninja - target ninja instead of GNU make"
27 echo "clangx.y - optional argument to build using clang version x.y."
28 echo "cross - optional argument to signify cross compilation,"
29 echo " - will use ROOTFS_DIR environment variable if set."
30 echo "crosscomponent - optional argument to build cross-architecture component,"
31 echo " - will use CAC_ROOTFS_DIR environment variable if set."
32 echo "pgoinstrument - generate instrumented code for profile guided optimization enabled binaries."
33 echo "ibcinstrument - generate IBC-tuning-enabled native images when invoking crossgen."
34 echo "configureonly - do not perform any builds; just configure the build."
35 echo "skipconfigure - skip build configuration."
36 echo "skipnative - do not build native components."
37 echo "skipmscorlib - do not build mscorlib.dll."
38 echo "skiptests - skip the tests in the 'tests' subdirectory."
39 echo "skipnuget - skip building nuget packages."
40 echo "skiprestoreoptdata - skip restoring optimization data used by profile-based optimizations."
41 echo "portableLinux - build for Portable Linux Distribution"
42 echo "verbose - optional argument to enable verbose build output."
43 echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
44 echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
45 echo "-sequential: force a non-parallel build ^(default is to build in parallel"
46 echo " using all processors^)."
47 echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
48 echo "-Rebuild: passes /t:rebuild to the build projects."
49 echo "stripSymbols - Optional argument to strip native symbols during the build."
50 echo "skipgenerateversion - disable version generation even if MSBuild is supported."
51 echo "cmakeargs - user-settable additional arguments passed to CMake."
52 echo "bindir - output directory (defaults to $__ProjectRoot/bin)"
53 echo "buildstandalonegc - builds the GC in a standalone mode. Can't be used with \"cmakeargs\"."
54 echo "msbuildonunsupportedplatform - build managed binaries even if distro is not officially supported."
60 if [ "$__HostOS" == "Linux" ]; then
61 if [ ! -e /etc/os-release ]; then
62 echo "WARNING: Can not determine runtime id for current distro."
65 source /etc/os-release
66 __HostDistroRid="$ID.$VERSION_ID-$__HostArch"
73 if [ $__CrossBuild == 1 ]; then
74 if [ "$__BuildOS" == "Linux" ]; then
75 if [ ! -e $ROOTFS_DIR/etc/os-release ]; then
76 echo "WARNING: Can not determine runtime id for current distro."
79 source $ROOTFS_DIR/etc/os-release
80 export __DistroRid="$ID.$VERSION_ID-$__BuildArch"
84 export __DistroRid="$__HostDistroRid"
87 # Portable builds target the base RID only for Linux based platforms
88 if [ $__PortableLinux == 1 ]; then
89 export __DistroRid="linux-$__BuildArch"
95 echo Setting up directories for build
97 mkdir -p "$__RootBinDir"
100 mkdir -p "$__IntermediatesDir"
102 if [ $__CrossBuild == 1 ]; then
103 mkdir -p "$__CrossComponentBinDir"
104 mkdir -p "$__CrossCompIntermediatesDir"
108 # Check the system to ensure the right prereqs are in place
112 echo "Checking prerequisites..."
114 # Check presence of CMake on the path
115 hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
118 hash clang-$__ClangMajorVersion.$__ClangMinorVersion 2>/dev/null || hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null || hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
124 # if msbuild is not supported, then set __SkipRestoreOptData to 1
125 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipRestoreOptData=1; fi
126 if [ $__SkipRestoreOptData == 0 ]; then
127 echo "Restoring the OptimizationData package"
128 "$__ProjectRoot/run.sh" sync -optdata
130 echo "Failed to restore the optimization data package."
136 generate_event_logging_sources()
138 if [ $__SkipCoreCLR == 1 ]; then
142 # Event Logging Infrastructure
143 __GeneratedIntermediate="$__IntermediatesDir/Generated"
144 __GeneratedIntermediateEventProvider="$__GeneratedIntermediate/eventprovider_new"
145 if [[ -d "$__GeneratedIntermediateEventProvider" ]]; then
146 rm -rf "$__GeneratedIntermediateEventProvider"
149 if [[ ! -d "$__GeneratedIntermediate/eventprovider" ]]; then
150 mkdir -p "$__GeneratedIntermediate/eventprovider"
153 mkdir -p "$__GeneratedIntermediateEventProvider"
154 if [[ $__SkipCoreCLR == 0 || $__ConfigureOnly == 1 ]]; then
155 echo "Laying out dynamically generated files consumed by the build system "
156 echo "Laying out dynamically generated Event Logging Test files"
157 $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatEventing.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst" --testdir "$__GeneratedIntermediateEventProvider/tests"
159 if [[ $? != 0 ]]; then
163 #determine the logging system
166 echo "Laying out dynamically generated Event Logging Implementation of Lttng"
167 $PYTHON -B -Wall -Werror "$__ProjectRoot/src/scripts/genXplatLttng.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__GeneratedIntermediateEventProvider"
168 if [[ $? != 0 ]]; then
177 echo "Cleaning the temp folder of dynamically generated Event Logging files"
178 $PYTHON -B -Wall -Werror -c "import sys;sys.path.insert(0,\"$__ProjectRoot/src/scripts\"); from Utilities import *;UpdateDirectory(\"$__GeneratedIntermediate/eventprovider\",\"$__GeneratedIntermediateEventProvider\")"
179 if [[ $? != 0 ]]; then
183 rm -rf "$__GeneratedIntermediateEventProvider"
190 intermediatesForBuild="$3"
191 extraCmakeArguments="$4"
194 if [ $skipCondition == 1 ]; then
195 echo "Skipping $message build."
199 # All set to commence the build
200 echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
205 if [ $__UseNinja == 1 ]; then
207 buildFile="build.ninja"
208 if ! buildTool=$(command -v ninja || command -v ninja-build); then
209 echo "Unable to locate ninja!" 1>&2
214 if [ $__SkipConfigure == 0 ]; then
215 # if msbuild is not supported, then set __SkipGenerateVersion to 1
216 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
217 # Drop version.cpp file
218 __versionSourceFile="$intermediatesForBuild/version.cpp"
219 if [ $__SkipGenerateVersion == 0 ]; then
221 "$__ProjectRoot/run.sh" build -Project=$__ProjectDir/build.proj -generateHeaderUnix -NativeVersionSourceFile=$__versionSourceFile $__RunArgs $__UnprocessedBuildArgs
223 # Generate the dummy version.cpp, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
224 __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
225 if [ -e $__versionSourceFile ]; then
226 read existingVersionSourceLine < $__versionSourceFile
228 if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
229 echo $__versionSourceLine > $__versionSourceFile
234 pushd "$intermediatesForBuild"
235 # Regenerate the CMake solution
236 echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator $extraCmakeArguments $__cmakeargs"
237 "$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator "$extraCmakeArguments" "$__cmakeargs"
241 if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
242 echo "Failed to generate $message build project!"
246 # Get the number of processors available to the scheduler
247 # Other techniques such as `nproc` only get the number of
248 # processors available to a single process.
249 if [ `uname` = "FreeBSD" ]; then
250 NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
251 elif [ `uname` = "NetBSD" ]; then
252 NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
254 NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
258 if [ $__ConfigureOnly == 1 ]; then
259 echo "Finish configuration & skipping $message build."
263 # Check that the makefiles were created.
264 pushd "$intermediatesForBuild"
266 echo "Executing $buildTool install -j $NumProc"
268 $buildTool install -j $NumProc
270 echo "Failed to build $message."
277 build_cross_arch_component()
279 __SkipCrossArchBuild=1
281 # check supported cross-architecture components host(__HostArch)/target(__BuildArch) pair
282 if [[ "$__BuildArch" == "arm" && "$__CrossArch" == "x86" ]]; then
283 export CROSSCOMPILE=0
284 __SkipCrossArchBuild=0
286 # building x64-host/arm-target cross-architecture component need to use cross toolchain of x86
287 if [ "$__HostArch" == "x64" ]; then
288 export CROSSCOMPILE=1
295 export __CMakeBinDir="$__CrossComponentBinDir"
296 export CROSSCOMPONENT=1
299 if [ $CROSSCOMPILE == 1 ]; then
300 TARGET_ROOTFS="$ROOTFS_DIR"
301 if [ -n "$CAC_ROOTFS_DIR" ]; then
302 export ROOTFS_DIR="$CAC_ROOTFS_DIR"
304 export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__CrossArch"
308 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_ARCH=$__BuildArch -DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion"
309 build_native $__SkipCrossArchBuild "$__CrossArch" "$__CrossCompIntermediatesDir" "$__ExtraCmakeArgs" "cross-architecture component"
311 # restore ROOTFS_DIR, CROSSCOMPONENT, and CROSSCOMPILE
312 if [ -n "$TARGET_ROOTFS" ]; then
313 export ROOTFS_DIR="$TARGET_ROOTFS"
315 export CROSSCOMPONENT=
316 export CROSSCOMPILE=1
319 isMSBuildOnNETCoreSupported()
321 # This needs to be updated alongwith corresponding changes to netci.groovy.
322 __isMSBuildOnNETCoreSupported=0
324 if [ "$__HostArch" == "x64" ]; then
325 if [ "$__HostOS" == "Linux" ]; then
326 case "$__HostDistroRid" in
328 __isMSBuildOnNETCoreSupported=1
331 __isMSBuildOnNETCoreSupported=1
334 __isMSBuildOnNETCoreSupported=1
337 __isMSBuildOnNETCoreSupported=1
340 __isMSBuildOnNETCoreSupported=1
343 __isMSBuildOnNETCoreSupported=1
346 __isMSBuildOnNETCoreSupported=1
349 __isMSBuildOnNETCoreSupported=1
352 __isMSBuildOnNETCoreSupported=1
355 __isMSBuildOnNETCoreSupported=1
358 __isMSBuildOnNETCoreSupported=$__msbuildonunsupportedplatform
360 elif [ "$__HostOS" == "OSX" ]; then
361 __isMSBuildOnNETCoreSupported=1
368 if [ $__SkipCoreCLR == 0 -a -e $__BinDir/crossgen ]; then
369 echo "Generating native image for System.Private.CoreLib."
370 $__BinDir/crossgen $__IbcTuning $__BinDir/System.Private.CoreLib.dll
371 if [ $? -ne 0 ]; then
372 echo "Failed to generate native image for System.Private.CoreLib."
376 if [ "$__BuildOS" == "Linux" ]; then
377 echo "Generating symbol file for System.Private.CoreLib."
378 $__BinDir/crossgen /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.ni.dll
379 if [ $? -ne 0 ]; then
380 echo "Failed to generate symbol file for System.Private.CoreLib."
390 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
391 echo "System.Private.CoreLib.dll build unsupported."
395 if [ $__SkipMSCorLib == 1 ]; then
396 echo "Skipping building System.Private.CoreLib."
400 echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
404 if [[ "$__IbcTuning" -eq "" ]]; then
405 __ExtraBuildArgs="$__ExtraBuildArgs -OptimizationDataDir=\"$__PackagesDir/optimization.$__BuildOS-$__BuildArch.IBC.CoreCLR/$__IbcOptDataVersion/data/\""
406 __ExtraBuildArgs="$__ExtraBuildArgs -EnableProfileGuidedOptimization=true"
408 $__ProjectRoot/run.sh build -Project=$__ProjectDir/build.proj -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__ExtraBuildArgs $__UnprocessedBuildArgs
410 if [ $? -ne 0 ]; then
411 echo "Failed to build managed components."
415 # The cross build generates a crossgen with the target architecture.
416 if [ $__CrossBuild != 1 ]; then
417 # The architecture of host pc must be same architecture with target.
418 if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
420 elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
422 elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
430 generate_NugetPackages()
432 # We can only generate nuget package if we also support building mscorlib as part of this build.
433 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
434 echo "Nuget package generation unsupported."
438 # Since we can build mscorlib for this OS, did we build the native components as well?
439 if [ $__SkipCoreCLR == 1 ]; then
440 echo "Unable to generate nuget packages since native components were not built."
444 echo "Generating nuget packages for "$__BuildOS
447 $__ProjectRoot/run.sh build -Project=$__SourceDir/.nuget/packages.builds -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
449 if [ $? -ne 0 ]; then
450 echo "Failed to generate Nuget packages."
455 echo "Commencing CoreCLR Repo build"
457 # Argument types supported by this script:
459 # Build architecture - valid values are: x64, ARM.
460 # Build Type - valid values are: Debug, Checked, Release
462 # Set the default arguments for build
464 # Obtain the location of the bash script to figure out where the root of the repo is.
465 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
467 # Use uname to determine what the CPU is.
469 # Some Linux platforms report unknown for platform, but the arch for machine.
470 if [ "$CPUName" == "unknown" ]; then
476 echo "Unsupported CPU $CPUName detected, build might not succeed!"
487 echo "Unsupported CPU $CPUName detected, build might not succeed!"
498 echo "Unknown CPU $CPUName detected, configuring as if for x64"
504 # Use uname to determine what the OS is.
538 echo "Unsupported OS $OSName detected, configuring as if for Linux"
546 __IncludeTests=Include_Tests
548 # Set the various build properties here so that CMake and MSBuild can pick them up
549 __ProjectDir="$__ProjectRoot"
550 __SourceDir="$__ProjectDir/src"
551 __PackagesDir="$__ProjectDir/packages"
552 __RootBinDir="$__ProjectDir/bin"
553 __UnprocessedBuildArgs=
566 __SkipRestoreOptData=0
568 __ClangMajorVersion=0
569 __ClangMinorVersion=0
570 __NuGetPath="$__PackagesDir/NuGet.exe"
574 __SkipGenerateVersion=0
577 __msbuildonunsupportedplatform=0
578 __PgoOptDataVersion=""
579 __IbcOptDataVersion=""
582 if [ $# -le 0 ]; then
586 lowerI="$(echo $1 | awk '{print tolower($0)}')"
626 __CodeCoverage=Coverage
634 if [ "$__BuildOS" == "Linux" ]; then
637 echo "ERROR: portableLinux not supported for non-Linux platforms."
647 __cmakeargs="$__cmakeargs -DSTRIP_SYMBOLS=true"
651 __ClangMajorVersion=3
652 __ClangMinorVersion=5
656 __ClangMajorVersion=3
657 __ClangMinorVersion=6
661 __ClangMajorVersion=3
662 __ClangMinorVersion=7
666 __ClangMajorVersion=3
667 __ClangMinorVersion=8
671 __ClangMajorVersion=3
672 __ClangMinorVersion=9
684 __IbcTuning="/Tuning"
698 # Use "skipnative" to use the same option name as build.cmd.
703 # Accept "skipcoreclr" for backwards-compatibility.
716 __SkipGenerateVersion=1
720 __SkipRestoreOptData=1
739 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
747 if [ ! -d $__RootBinDir ]; then
750 __RootBinParent=$(dirname $__RootBinDir)
751 __RootBinName=${__RootBinDir##*/}
752 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
755 echo "ERROR: 'bindir' requires a non-empty option argument"
760 __cmakeargs="-DFEATURE_STANDALONE_GC=1"
762 msbuildonunsupportedplatform)
763 __msbuildonunsupportedplatform=1
766 __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
773 __RunArgs="-BuildArch=$__BuildArch -BuildType=$__BuildType -BuildOS=$__BuildOS"
775 # Configure environment if we are doing a verbose build
776 if [ $__VerboseBuild == 1 ]; then
778 __RunArgs="$__RunArgs -verbose"
781 # Set default clang version
782 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
783 if [ $__CrossBuild == 1 ]; then
784 __ClangMajorVersion=3
785 __ClangMinorVersion=6
787 __ClangMajorVersion=3
788 __ClangMinorVersion=5
792 # Set dependent variables
793 __LogsDir="$__RootBinDir/Logs"
795 # init the host distro name
798 # Set the remaining variables based upon the determined build configuration
799 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
800 __PackagesBinDir="$__BinDir/.nuget"
801 __ToolsDir="$__RootBinDir/tools"
802 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
803 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
804 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
805 __isMSBuildOnNETCoreSupported=0
806 __CrossComponentBinDir="$__BinDir"
807 __CrossCompIntermediatesDir="$__IntermediatesDir/crossgen"
809 __CrossArch="$__HostArch"
810 if [[ "$__HostArch" == "x64" && "$__BuildArch" == "arm" ]]; then
813 if [ $__CrossBuild == 1 ]; then
814 __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
816 __CrossgenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$BuildArch.$__BuildType.log"
817 __CrossgenExe="$__CrossComponentBinDir/crossgen"
819 # Init if MSBuild for .NET Core is supported for this platform
820 isMSBuildOnNETCoreSupported
822 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
823 # This is needed by CLI to function.
824 if [ -z "$HOME" ]; then
825 if [ ! -d "$__ProjectDir/temp_home" ]; then
828 export HOME=$__ProjectDir/temp_home
829 echo "HOME not defined; setting it to $HOME"
832 # Specify path to be set for CMAKE_INSTALL_PREFIX.
833 # This is where all built CoreClr libraries will copied to.
834 export __CMakeBinDir="$__BinDir"
836 # Configure environment if we are doing a cross compile.
837 if [ $__CrossBuild == 1 ]; then
838 export CROSSCOMPILE=1
839 if ! [[ -n "$ROOTFS_DIR" ]]; then
840 export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
844 # Parse the optdata package version from its project.json file
845 optDataProjectJsonPath="$__ProjectRoot/src/.nuget/optdata/project.json"
846 if [ -f $optDataProjectJsonPath ]; then
847 __PgoOptDataVersion=$("$__ProjectRoot/extract-from-json.py" -rf $optDataProjectJsonPath dependencies optimization.PGO.CoreCLR)
848 __IbcOptDataVersion=$("$__ProjectRoot/extract-from-json.py" -rf $optDataProjectJsonPath dependencies optimization.IBC.CoreCLR)
851 # init the target distro name
854 # Make the directories necessary for build if they don't exist
860 # Restore the package containing profile counts for profile-guided optimizations
863 # Generate event logging infrastructure sources
864 generate_event_logging_sources
866 # Build the coreclr (native) components.
867 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion"
868 build_native $__SkipCoreCLR "$__BuildArch" "$__IntermediatesDir" "$__ExtraCmakeArgs" "CoreCLR component"
870 # Build cross-architecture components
871 if [[ $__CrossBuild == 1 && $__DoCrossArchBuild == 1 ]]; then
872 build_cross_arch_component
875 # Build System.Private.CoreLib.
879 # Generate nuget packages
880 if [ $__SkipNuget != 1 ]; then
881 generate_NugetPackages
887 echo "Repo successfully built."
888 echo "Product binaries are available at $__BinDir"